function [Lu] = updatechol(L,index, AddToA, type)
%
% insertion d'une ligne+col apres index
% index <= length(L)
% L carree diag en bas
%

% Vincent Guigue 2005

if type ==1
    AddToL = [];
    
    % mise � la bonne taille de la matrice
    n  = length(L);
    Lu = zeros(n+1,n+1);
    Lu(1:index,1:index)         = L(1:index,1:index); % 1er carre 
    Lu(index+2:end,1:index)     = L(index+1:end,1:index); % 2
    Lu(1:index,index+2:end)     = L(1:index,index+1:end); % 3
    Lu(index+2:end,index+2:end) = L(index+1:end,index+1:end); % 4
    
    % description de la index^e ligne de L
    % keyboard
    for j=1:index
        sumligne = 0;
        for k=1:j-1
            sumligne  = sumligne + Lu(index+1,k)*Lu(j,k);
        end
        Lu(index+1,j) = (AddToA(j) - sumligne)/Lu(j,j);
    end
    
    % terme diag
    sumligne = 0;
    for k=1:index
        sumligne  = sumligne + Lu(index+1,k)^2;
    end
    Lu(index+1,index+1) = sqrt(AddToA(index+1) - sumligne);
    
    % colonne index^e
    % keyboard
    j = index+1;
    for i=index+2:n+1
        sumligne = 0;
        for k=1:j-1
            sumligne  = sumligne + Lu(i,k)*Lu(j,k);
        end
        Lu(i,j) = (AddToA(i) - sumligne)/Lu(j,j);
    end
    
elseif type==-1
    % mise � la bonne taille de la matrice
    n  = length(L);
    Lu = zeros(n-1,n-1);
    Lu(1:index-1,1:index-1)     = L(1:index-1  ,1:index-1); % 1er carre 
    Lu(index:end,1:index-1)     = L(index+1:end,1:index-1); % 2
    Lu(1:index-1,index:end)     = L(1:index-1,index+1:end); % 3
    Lu(index:end,index:end)     = L(index+1:end,index+1:end); % 4
    
else
    error('Impossible update !!');
end