function varargout = demonstration(varargin)

% DEMONSTRATION M-file for demonstration.fig
%      DEMONSTRATION, by itself, creates a new DEMONSTRATION or raises the existing
%      singleton*.
%
%      H = DEMONSTRATION returns the handle to a new DEMONSTRATION or the handle to
%      the existing singleton*.
%

% Last Modified by Gaelle Loosli 05-Dec-2004 11:47:27

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @demonstration_OpeningFcn, ...
    'gui_OutputFcn',  @demonstration_OutputFcn, ...
    'gui_LayoutFcn',  [], ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demonstration is made visible.
function demonstration_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);
addpath('./examples/');

function varargout = demonstration_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;

function figure1_CloseRequestFcn(hObject, eventdata, handles)
delete(hObject);

function dataset_CreateFcn(hObject, eventdata, handles)
function slack_CreateFcn(hObject, eventdata, handles)
function paramGaussian_CreateFcn(hObject, eventdata, handles)
function orderPoly_CreateFcn(hObject, eventdata, handles)
function paramPoly_CreateFcn(hObject, eventdata, handles)
function mode_CreateFcn(hObject, eventdata, handles)
function invariant_CreateFcn(hObject, eventdata, handles)
function paramEpanech_CreateFcn(hObject, eventdata, handles)
function results_CreateFcn(hObject, eventdata, handles)
function methode_CreateFcn(hObject, eventdata, handles)
function nbapp_CreateFcn(hObject, eventdata, handles)
function nbtest_CreateFcn(hObject, eventdata, handles)
function dataSigma_CreateFcn(hObject, eventdata, handles)
%======================================================================


function slack_Callback(hObject, eventdata, handles)
function paramGaussian_Callback(hObject, eventdata, handles)
function orderPoly_Callback(hObject, eventdata, handles)
function paramPoly_Callback(hObject, eventdata, handles)
function mode_Callback(hObject, eventdata, handles)
function results_Callback(hObject, eventdata, handles)
function paramEpanech_Callback(hObject, eventdata, handles)
function invariant_Callback(hObject, eventdata, handles)
function methode_Callback(hObject, eventdata, handles)
function nbapp_Callback(hObject, eventdata, handles)
function nbtest_Callback(hObject, eventdata, handles)
function dataSigma_Callback(hObject, eventdata, handles)

function epanech_Callback(hObject, eventdata, handles)
Hpoly = findobj('Tag','poly');
Hgaussian = findobj('Tag','gaussian');
if get(hObject,'Value')==1
    set(Hpoly,'Value',0);
    set(Hgaussian,'Value',0);
end

function gaussian_Callback(hObject, eventdata, handles)
Hpoly = findobj('Tag','poly');
Hepanech = findobj('Tag','epanech');
if get(hObject,'Value')==1
    set(Hpoly,'Value',0);
    set(Hepanech,'Value',0);
end

function poly_Callback(hObject, eventdata, handles)
Hgaussian = findobj('Tag','gaussian');
Hepanech = findobj('Tag','epanech');
if get(hObject,'Value')==1
    set(Hgaussian,'Value',0);
    set(Hepanech,'Value',0);
end


function dataset_Callback(hObject, eventdata, handles)
Hinv = findobj('Tag','invariant');
Hmode = findobj('Tag','mode');
Hresult = findobj('Tag','results');
str = get(hObject,'String');
dataType = str(get(hObject,'Value'));
switch mat2str(cell2mat(dataType))
    case 'Gaussians'
        set(Hinv,'Value',1);
        set(Hmode,'Value',1);
        set(Hresult,'String','Use binary or 1class mode');
    case 'Checkers'
        set(Hinv,'Value',1);
        set(Hmode,'Value',1);
        set(Hresult,'String','Use binary mode');        
    case 'Checkers Multiclass'
        set(Hinv,'Value',1);
        set(Hmode,'Value',2);
        set(Hresult,'String','Use 1vs1 or 1vsAll mode');        
    case 'Carpette'
        set(Hinv,'Value',1);
        set(Hmode,'Value',2);
        set(Hresult,'String','Use 1vs1 or 1vsAll mode');         
    case 'Clown'
        set(Hinv,'Value',1);
        set(Hmode,'Value',1);
        set(Hresult,'String','Use binary mode');          
    case 'CosExp'
        set(Hinv,'Value',1);
        set(Hmode,'Value',1);
        set(Hresult,'String','Use binary mode');          
    case 'USPS'
        set(Hinv,'Value',1);
        set(Hmode,'Value',2);
        set(Hresult,'String','Use 1vs1 or 1vsAll mode, invariant or 1class');          
end


function lancer_Callback(hObject, eventdata, handles)
global svModel;
Hdata = findobj('Tag','dataset');
Hmode = findobj('Tag','mode');
Hgaussian = findobj('Tag','gaussian');
Hepanech = findobj('Tag','epanech');
Hpoly = findobj('Tag','poly');
Hslack = findobj('Tag','slack');
Hresult = findobj('Tag','results');
Hmeth = findobj('Tag','methode');
Hnbapp = findobj('Tag','nbapp');
Hnbtest = findobj('Tag','nbtest');
Hsig = findobj('Tag','dataSigma');
Hinv = findobj('Tag','invariant');
str = get(Hdata,'String');
dataType = str(get(Hdata,'Value'));
if get(Hmode,'Value')==1
    multiclass='';
elseif get(Hmode,'Value')==2
    multiclass='1vs1';
elseif get(Hmode,'Value')==3
    multiclass='1vsall';
elseif get(Hmode,'Value')==4
    multiclass='1class';
end

switch mat2str(cell2mat(dataType))
    case 'Gaussians'
        if strcmp(multiclass,'1class')
            [train_patterns, train_labels, test_patterns, test_labels] = dataset('oneclass',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
            disp('one class');
        else
            [train_patterns, train_labels, test_patterns, test_labels] = dataset('gaussian',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
        end    
    case 'Checkers'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('checkers',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
    case 'Checkers Multiclass'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('multiclasscheckers',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
    case 'Carpette'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('carpette',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));  
    case 'Clown'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('clowns',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
    case 'CosExp'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('cosexp',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
    case 'USPS'
        load('./database/usps_perm.mat');  
        [rien,train_labels] = max(train_labels',[],2);
        [rien,test_labels] = max(test_labels',[],2);
end

donnees = data(train_patterns, train_labels, test_patterns, test_labels);

str = get(Hmeth,'String');
method = mat2str(cell2mat(str(get(Hmeth,'Value'))));
if strcmp(method,'Cholesky')
    meth = 'chol';
elseif strcmp(method,'QR')
    meth = 'qr';
else
    meth = 'shmo';
end
parametres = param(str2num(get(Hslack,'String')),50,multiclass,meth,10^-5);
if get(Hinv,'Value')==2
	parametres.type = 'invariant';
	parametres.transformations = [1:4];
end
if get(Hgaussian,'Value')==1
    ker = 'rbf';
    Hparam = findobj('Tag','paramGaussian');
    p = str2num(get(Hparam,'String'));
elseif get(Hpoly,'Value')==1
    Hparam = findobj('Tag','paramPoly');
    Hordre = findobj('Tag','orderPoly');
    p = [str2num(get(Hordre,'String'));str2num(get(Hparam,'String'))];
    ker = 'poly';
else 
    ker = 'epanech';
    Hparam = findobj('Tag','paramEpanech');
    p = str2num(get(Hparam,'String'));
end
noyau = kernel(ker,p);
tic;
trainSVM(donnees,noyau,parametres);
temps = toc;
prediction = testSVM;
perf = length(find(donnees.testlab==prediction(:,1)))/length(prediction);
if strcmp(multiclass,'')|strcmp(multiclass,'1class')
    perf = length(find(sign(donnees.testlab)==sign(prediction(:,1))))/length(prediction);
end
set(Hresult,'String',['good classification : ', num2str(perf*100), '%  -- training time: ', num2str(temps)]);

Haxes = findobj('Tag','figureDemo');
axes(Haxes);
if size(donnees.trainvec,1)==2
     colormap(gray);
    [xtesta1,xtesta2]=meshgrid([-2:0.1:2],[-2:0.1:2]);
    [na,nb]=size(xtesta1);
    xtest1=reshape(xtesta1,1,na*nb);
    xtest2=reshape(xtesta2,1,na*nb);
    xtest=[xtest1;xtest2];
    svModel.data.testvec = xtest;
    ypred = testSVM;
    ypredmat=reshape(ypred(:,1),na,nb);
    contourf(xtesta1,xtesta2,ypredmat,30);shading flat
    hold on
    
    if max(donnees.testlab)==1
        [cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'k');        
        plot(donnees.trainvec(1,find(donnees.trainlab==1)),donnees.trainvec(2,find(donnees.trainlab==1)),'rx');
        plot(donnees.trainvec(1,find(donnees.trainlab==-1)),donnees.trainvec(2,find(donnees.trainlab==-1)),'gx');
        h1 = plot(donnees.trainvec(1,svModel.model.indices{1}),donnees.trainvec(2,svModel.model.indices{1}),'rs');
	set(h1,'LineWidth',3);
        plot(donnees.testvec(1,find(donnees.testlab==-1)),donnees.testvec(2,find(donnees.testlab==-1)),'go');
        plot(donnees.testvec(1,find(donnees.testlab==1)),donnees.testvec(2,find(donnees.testlab==1)),'ro');
        hold off;
        set(Haxes,'Tag','figureDemo');
        axis ([-2 2 -2 2]);
    else 
        style=['x+*vx+*vd'];
        color=['ybcgmrkyb'];
        for i=1:max(donnees.testlab)
            plot(donnees.trainvec(1,donnees.trainlab==i),donnees.trainvec(2,donnees.trainlab==i),[style(i) color(i)]); 
	    if strcmp(multiclass,'1vs1')
	    else
            	h1=plot(donnees.trainvec(1,svModel.model.indices{i}),donnees.trainvec(2,svModel.model.indices{i}),'rs');
	    	set(h1,'LineWidth',3);
	    end
        end; 
	[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'r');
	try
        clabel(cs,h);
	catch
	end
        set(Haxes,'Tag','figureDemo');
        axis ([-2 2 -2 2]);  
        hold off;
    end
end
clear global svModel;



function zoomin_Callback(hObject, eventdata, handles)
%Haxes = findobj('Tag','figureDemo');
%zoom(Haxes);
%set(Haxes,'Tag','figureDemo');
zoom;

function zoomout_Callback(hObject, eventdata, handles)
% Haxes = findobj('Tag','figureDemo');
% zoom(Haxes,'out');
% set(Haxes,'Tag','figureDemo');
zoom out;



% --------------------------------------------------------------------
function varargout = validation_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.validation.
disp('validation Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = parametersCross_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.parametersCross.
disp('parametersCross Callback not implemented yet.')


% --------------------------------------------------------------------
function varargout = slacksCross_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.slacksCross.
disp('slacksCross Callback not implemented yet.')