function varargout = demonstration_export(varargin)

% DEMONSTRATION_EXPORT M-file for demonstration_export.fig
%      DEMONSTRATION_EXPORT, by itself, creates a new DEMONSTRATION_EXPORT or raises the existing
%      singleton*.
%
%      H = DEMONSTRATION_EXPORT returns the handle to a new DEMONSTRATION_EXPORT or the handle to
%      the existing singleton*.
%

% Last Modified by Gaelle Loosli 05-Dec-2004 11:47:27

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @demonstration_export_OpeningFcn, ...
    'gui_OutputFcn',  @demonstration_export_OutputFcn, ...
    'gui_LayoutFcn',  @demonstration_export_LayoutFcn, ...
    'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demonstration_export is made visible.
function demonstration_export_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);
addpath('./examples/');

function varargout = demonstration_export_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;

function figure1_CloseRequestFcn(hObject, eventdata, handles)
delete(hObject);

function dataset_CreateFcn(hObject, eventdata, handles)
function slack_CreateFcn(hObject, eventdata, handles)
function paramGaussian_CreateFcn(hObject, eventdata, handles)
function orderPoly_CreateFcn(hObject, eventdata, handles)
function paramPoly_CreateFcn(hObject, eventdata, handles)
function mode_CreateFcn(hObject, eventdata, handles)
function invariant_CreateFcn(hObject, eventdata, handles)
function paramEpanech_CreateFcn(hObject, eventdata, handles)
function results_CreateFcn(hObject, eventdata, handles)
function methode_CreateFcn(hObject, eventdata, handles)
function nbapp_CreateFcn(hObject, eventdata, handles)
function nbtest_CreateFcn(hObject, eventdata, handles)
function dataSigma_CreateFcn(hObject, eventdata, handles)
%======================================================================


function slack_Callback(hObject, eventdata, handles)
function paramGaussian_Callback(hObject, eventdata, handles)
function orderPoly_Callback(hObject, eventdata, handles)
function paramPoly_Callback(hObject, eventdata, handles)
function mode_Callback(hObject, eventdata, handles)
function results_Callback(hObject, eventdata, handles)
function paramEpanech_Callback(hObject, eventdata, handles)
function invariant_Callback(hObject, eventdata, handles)
function methode_Callback(hObject, eventdata, handles)
function nbapp_Callback(hObject, eventdata, handles)
function nbtest_Callback(hObject, eventdata, handles)
function dataSigma_Callback(hObject, eventdata, handles)

function epanech_Callback(hObject, eventdata, handles)
Hpoly = findobj('Tag','poly');
Hgaussian = findobj('Tag','gaussian');
if get(hObject,'Value')==1
    set(Hpoly,'Value',0);
    set(Hgaussian,'Value',0);
end

function gaussian_Callback(hObject, eventdata, handles)
Hpoly = findobj('Tag','poly');
Hepanech = findobj('Tag','epanech');
if get(hObject,'Value')==1
    set(Hpoly,'Value',0);
    set(Hepanech,'Value',0);
end

function poly_Callback(hObject, eventdata, handles)
Hgaussian = findobj('Tag','gaussian');
Hepanech = findobj('Tag','epanech');
if get(hObject,'Value')==1
    set(Hgaussian,'Value',0);
    set(Hepanech,'Value',0);
end


function dataset_Callback(hObject, eventdata, handles)
Hinv = findobj('Tag','invariant');
Hmode = findobj('Tag','mode');
Hresult = findobj('Tag','results');
str = get(hObject,'String');
dataType = str(get(hObject,'Value'));
switch mat2str(cell2mat(dataType))
    case 'Gaussians'
        set(Hinv,'Value',1);
        set(Hmode,'Value',1);
        set(Hresult,'String','Use binary or 1class mode');
    case 'Checkers'
        set(Hinv,'Value',1);
        set(Hmode,'Value',1);
        set(Hresult,'String','Use binary mode');        
    case 'Checkers Multiclass'
        set(Hinv,'Value',1);
        set(Hmode,'Value',2);
        set(Hresult,'String','Use 1vs1 or 1vsAll mode');        
    case 'Carpette'
        set(Hinv,'Value',1);
        set(Hmode,'Value',2);
        set(Hresult,'String','Use 1vs1 or 1vsAll mode');         
    case 'Clown'
        set(Hinv,'Value',1);
        set(Hmode,'Value',1);
        set(Hresult,'String','Use binary mode');          
    case 'CosExp'
        set(Hinv,'Value',1);
        set(Hmode,'Value',1);
        set(Hresult,'String','Use binary mode');          
    case 'USPS'
        set(Hinv,'Value',1);
        set(Hmode,'Value',2);
        set(Hresult,'String','Use 1vs1 or 1vsAll mode, invariant or 1class');          
end


function lancer_Callback(hObject, eventdata, handles)
global svModel;
Hdata = findobj('Tag','dataset');
Hmode = findobj('Tag','mode');
Hgaussian = findobj('Tag','gaussian');
Hepanech = findobj('Tag','epanech');
Hpoly = findobj('Tag','poly');
Hslack = findobj('Tag','slack');
Hresult = findobj('Tag','results');
Hmeth = findobj('Tag','methode');
Hnbapp = findobj('Tag','nbapp');
Hnbtest = findobj('Tag','nbtest');
Hsig = findobj('Tag','dataSigma');
Hinv = findobj('Tag','invariant');
str = get(Hdata,'String');
dataType = str(get(Hdata,'Value'));
if get(Hmode,'Value')==1
    multiclass='';
elseif get(Hmode,'Value')==2
    multiclass='1vs1';
elseif get(Hmode,'Value')==3
    multiclass='1vsall';
elseif get(Hmode,'Value')==4
    multiclass='1class';
end

switch mat2str(cell2mat(dataType))
    case 'Gaussians'
        if strcmp(multiclass,'1class')
            [train_patterns, train_labels, test_patterns, test_labels] = dataset('oneclass',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
            disp('one class');
        else
            [train_patterns, train_labels, test_patterns, test_labels] = dataset('gaussian',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
        end    
    case 'Checkers'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('checkers',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
    case 'Checkers Multiclass'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('multiclasscheckers',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
    case 'Carpette'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('carpette',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));  
    case 'Clown'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('clowns',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
    case 'CosExp'
        [train_patterns, train_labels, test_patterns, test_labels] = dataset('cosexp',str2num(get(Hnbapp,'String')),str2num(get(Hnbtest,'String')),str2num(get(Hsig,'String')));
    case 'USPS'
        load('./database/usps_perm.mat');  
        [rien,train_labels] = max(train_labels',[],2);
        [rien,test_labels] = max(test_labels',[],2);
end

rn = randperm(length(train_labels));
donnees = data(train_patterns(:,rn), train_labels(rn), test_patterns, test_labels);

str = get(Hmeth,'String');
method = mat2str(cell2mat(str(get(Hmeth,'Value'))));
if strcmp(method,'Cholesky')
    meth = 'chol';
elseif strcmp(method,'QR')
    meth = 'qr';
else
    meth = 'shmo';
end
parametres = param(str2num(get(Hslack,'String')),100,multiclass,meth,10^-4);
if get(Hinv,'Value')==2
	parametres.type = 'invariant';
	parametres.transformations = [1:4];
end
if get(Hgaussian,'Value')==1
    ker = 'rbf';
    Hparam = findobj('Tag','paramGaussian');
    p = str2num(get(Hparam,'String'));
elseif get(Hpoly,'Value')==1
    Hparam = findobj('Tag','paramPoly');
    Hordre = findobj('Tag','orderPoly');
    p = [str2num(get(Hordre,'String'));str2num(get(Hparam,'String'))];
    ker = 'poly';
else 
    ker = 'epanech';
    Hparam = findobj('Tag','paramEpanech');
    p = str2num(get(Hparam,'String'));
end
noyau = kernel(ker,p);
tic;
trainSVM(donnees,noyau,parametres);
temps = toc;
prediction = testSVM;
perf = length(find(donnees.testlab==prediction(:,1)))/length(prediction);
if strcmp(multiclass,'')|strcmp(multiclass,'1class')
    perf = length(find(sign(donnees.testlab)==sign(prediction(:,1))))/length(prediction);
end
set(Hresult,'String',['good classification : ', num2str(perf*100), '%  -- training time: ', num2str(temps)]);

Haxes = findobj('Tag','figureDemo');
axes(Haxes);
if size(donnees.trainvec,1)==2
     colormap(gray);
    [xtesta1,xtesta2]=meshgrid([-2:0.1:2],[-2:0.1:2]);
    [na,nb]=size(xtesta1);
    xtest1=reshape(xtesta1,1,na*nb);
    xtest2=reshape(xtesta2,1,na*nb);
    xtest=[xtest1;xtest2];
    svModel.data.testvec = xtest;
    ypred = testSVM;
    ypredmat=reshape(ypred(:,1),na,nb);
    contourf(xtesta1,xtesta2,ypredmat,30);shading flat
    hold on
    
    if max(donnees.testlab)==1
        [cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'k');        
        %plot(donnees.trainvec(1,find(donnees.trainlab==1)),donnees.trainvec(2,find(donnees.trainlab==1)),'rx');
        %plot(donnees.trainvec(1,find(donnees.trainlab==-1)),donnees.trainvec(2,find(donnees.trainlab==-1)),'gx');
        h1 = plot(donnees.trainvec(1,svModel.model.indices{1}),donnees.trainvec(2,svModel.model.indices{1}),'bs');
	set(h1,'LineWidth',3);
        plot(donnees.testvec(1,find(donnees.testlab==-1)),donnees.testvec(2,find(donnees.testlab==-1)),'go');
        plot(donnees.testvec(1,find(donnees.testlab==1)),donnees.testvec(2,find(donnees.testlab==1)),'ro');
        hold off;
        set(Haxes,'Tag','figureDemo');
        axis ([-2 2 -2 2]);
    else 
        style=['x+*vx+*vd'];
        color=['ybcgmrkyb'];
        for i=1:max(donnees.testlab)
            plot(donnees.trainvec(1,donnees.trainlab==i),donnees.trainvec(2,donnees.trainlab==i),[style(i) color(i)]); 
	    if strcmp(multiclass,'1vs1')
	    else
            	h1=plot(donnees.trainvec(1,svModel.model.indices{i}),donnees.trainvec(2,svModel.model.indices{i}),'rs');
	    	set(h1,'LineWidth',3);
	    end
        end; 
	[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'r');
	try
        clabel(cs,h);
	catch
	end
        set(Haxes,'Tag','figureDemo');
        axis ([-2 2 -2 2]);  
        hold off;
    end
end
clear global svModel;



function zoomin_Callback(hObject, eventdata, handles)
%Haxes = findobj('Tag','figureDemo');
%zoom(Haxes);
%set(Haxes,'Tag','figureDemo');
zoom;

function zoomout_Callback(hObject, eventdata, handles)
% Haxes = findobj('Tag','figureDemo');
% zoom(Haxes,'out');
% set(Haxes,'Tag','figureDemo');
zoom out;


% --- Creates and returns a handle to the GUI figure. 
function h1 = demonstration_export_LayoutFcn(policy)
% policy - create a new figure or use a singleton. 'new' or 'reuse'.

persistent hsingleton;
if strcmpi(policy, 'reuse') & ishandle(hsingleton)
    h1 = hsingleton;
    return;
end

h1 = figure(...
'Units','characters',...
'PaperUnits',get(0,'defaultfigurePaperUnits'),...
'CloseRequestFcn','demonstration_export(''figure1_CloseRequestFcn'',gcf,[],guidata(gcf))',...
'Color',[0.937254901960784 0.937254901960784 0.937254901960784],...
'Colormap',[0 0 0.5625;0 0 0.625;0 0 0.6875;0 0 0.75;0 0 0.8125;0 0 0.875;0 0 0.9375;0 0 1;0 0.0625 1;0 0.125 1;0 0.1875 1;0 0.25 1;0 0.3125 1;0 0.375 1;0 0.4375 1;0 0.5 1;0 0.5625 1;0 0.625 1;0 0.6875 1;0 0.75 1;0 0.8125 1;0 0.875 1;0 0.9375 1;0 1 1;0.0625 1 1;0.125 1 0.9375;0.1875 1 0.875;0.25 1 0.8125;0.3125 1 0.75;0.375 1 0.6875;0.4375 1 0.625;0.5 1 0.5625;0.5625 1 0.5;0.625 1 0.4375;0.6875 1 0.375;0.75 1 0.3125;0.8125 1 0.25;0.875 1 0.1875;0.9375 1 0.125;1 1 0.0625;1 1 0;1 0.9375 0;1 0.875 0;1 0.8125 0;1 0.75 0;1 0.6875 0;1 0.625 0;1 0.5625 0;1 0.5 0;1 0.4375 0;1 0.375 0;1 0.3125 0;1 0.25 0;1 0.1875 0;1 0.125 0;1 0.0625 0;1 0 0;0.9375 0 0;0.875 0 0;0.8125 0 0;0.75 0 0;0.6875 0 0;0.625 0 0;0.5625 0 0],...
'IntegerHandle','off',...
'InvertHardcopy',get(0,'defaultfigureInvertHardcopy'),...
'MenuBar','none',...
'Name','demonstration',...
'NumberTitle','off',...
'PaperPosition',get(0,'defaultfigurePaperPosition'),...
'PaperSize',[20.98404194812 29.67743169791],...
'PaperType',get(0,'defaultfigurePaperType'),...
'Position',[103.8 7.92307692307695 217.6 53.5384615384615],...
'Renderer',get(0,'defaultfigureRenderer'),...
'RendererMode','manual',...
'HandleVisibility','callback',...
'Tag','figure1',...
'UserData',zeros(1,0));

setappdata(h1, 'GUIDEOptions', struct(...
'active_h', 1.340002e+002, ...
'taginfo', struct(...
'figure', 2, ...
'listbox', 3, ...
'popupmenu', 5, ...
'radiobutton', 4, ...
'text', 7, ...
'axes', 2, ...
'edit', 10, ...
'pushbutton', 5), ...
'override', 1, ...
'release', 13, ...
'resize', 'simple', ...
'accessibility', 'callback', ...
'mfile', 1, ...
'callbacks', 1, ...
'singleton', 1, ...
'syscolorfig', 1, ...
'lastSavedFile', 'D:\SVM-Toolbox\svmtoolbox\simpleSVM\demonstration.m'));


h2 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'Callback','demonstration_export(''dataset_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.0491474423269809 0.818313953488372 0.151454363089268 0.0348837209302326],...
'String',{ 'Checkers' 'Carpette' 'Checkers Multiclass' 'Gaussians' 'Clown' 'USPS' },...
'Style','popupmenu',...
'Value',1,...
'CreateFcn','demonstration_export(''dataset_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','dataset');


h3 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'Callback','demonstration_export(''gaussian_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.0491474423269809 0.736918604651163 0.151454363089268 0.0436046511627907],...
'String','Gaussian',...
'Style','radiobutton',...
'Value',1,...
'Tag','gaussian');


h4 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'Callback','demonstration_export(''poly_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.0491474423269809 0.691860465116279 0.151454363089268 0.0436046511627907],...
'String','Polynomial',...
'Style','radiobutton',...
'Tag','poly');


h5 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'FontSize',20,...
'ListboxTop',0,...
'Position',[0.299899699097292 0.924418604651163 0.402206619859579 0.0406976744186046],...
'String','SVM Toolbox',...
'Style','text',...
'Tag','text1');


h6 = axes(...
'Parent',h1,...
'CameraPosition',[0.5 0.5 9.16025403784439],...
'CameraPositionMode',get(0,'defaultaxesCameraPositionMode'),...
'Color',get(0,'defaultaxesColor'),...
'ColorOrder',get(0,'defaultaxesColorOrder'),...
'Position',[0.483455882352941 0.127873563218391 0.500919117647059 0.727011494252874],...
'XColor',get(0,'defaultaxesXColor'),...
'YColor',get(0,'defaultaxesYColor'),...
'ZColor',get(0,'defaultaxesZColor'),...
'Tag','figureDemo');


h7 = get(h6,'title');

set(h7,...
'Parent',h6,...
'Color',[0 0 0],...
'HorizontalAlignment','center',...
'Position',[0.5 1.01284584980237 1.00005459937205],...
'VerticalAlignment','bottom',...
'HandleVisibility','off');

h8 = get(h6,'xlabel');

set(h8,...
'Parent',h6,...
'Color',[0 0 0],...
'HorizontalAlignment','center',...
'Position',[0.498165137614679 -0.0464426877470356 1.00005459937205],...
'VerticalAlignment','cap',...
'HandleVisibility','off');

h9 = get(h6,'ylabel');

set(h9,...
'Parent',h6,...
'Color',[0 0 0],...
'HorizontalAlignment','center',...
'Position',[-0.0522935779816514 0.49703557312253 1.00005459937205],...
'Rotation',90,...
'VerticalAlignment','bottom',...
'HandleVisibility','off');

h10 = get(h6,'zlabel');

set(h10,...
'Parent',h6,...
'Color',[0 0 0],...
'HorizontalAlignment','right',...
'Position',[-0.96605504587156 1.19664031620553 1.00005459937205],...
'HandleVisibility','off',...
'Visible','off');

h11 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'BackgroundColor',[1 1 1],...
'Callback','demonstration_export(''slack_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.199598796389167 0.633720930232558 0.101303911735206 0.0319767441860465],...
'String','100',...
'Style','edit',...
'CreateFcn','demonstration_export(''slack_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','slack');


h12 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'BackgroundColor',[1 1 1],...
'Callback','demonstration_export(''paramGaussian_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.199598796389167 0.736918604651163 0.101303911735206 0.0319767441860465],...
'String','2',...
'Style','edit',...
'CreateFcn','demonstration_export(''paramGaussian_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','paramGaussian');


h13 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'BackgroundColor',[1 1 1],...
'Callback','demonstration_export(''orderPoly_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.199598796389167 0.691860465116279 0.101303911735206 0.0319767441860465],...
'String','3',...
'Style','edit',...
'CreateFcn','demonstration_export(''orderPoly_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','orderPoly');


h14 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'BackgroundColor',[1 1 1],...
'Callback','demonstration_export(''paramPoly_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.342026078234704 0.691860465116279 0.101303911735206 0.0319767441860465],...
'String','2',...
'Style','edit',...
'CreateFcn','demonstration_export(''paramPoly_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','paramPoly');


h15 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'Callback','demonstration_export(''mode_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.0491474423269809 0.488372093023256 0.151454363089268 0.0334302325581395],...
'String',{ 'Binary' 'Multiclass 1vs 1' 'Multiclass 1vs all' '1 class' },...
'Style','popupmenu',...
'Value',1,...
'CreateFcn','demonstration_export(''mode_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','mode');


h16 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'Callback','demonstration_export(''invariant_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.0491474423269809 0.441860465116279 0.151454363089268 0.0319767441860465],...
'String',{ 'None' 'Invariant' },...
'Style','popupmenu',...
'Value',1,...
'CreateFcn','demonstration_export(''invariant_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','invariant');


h17 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'Callback','demonstration_export(''epanech_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.078234704112337 0.0101744186046512 0.151454363089268 0.0436046511627907],...
'String','Epanechnikov',...
'Style','radiobutton',...
'Tag','epanech',...
'Visible','off');


h18 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'BackgroundColor',[1 1 1],...
'Callback','demonstration_export(''paramEpanech_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.267803410230692 0.0218023255813954 0.101303911735206 0.0319767441860465],...
'String','sigma',...
'Style','edit',...
'CreateFcn','demonstration_export(''paramEpanech_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','paramEpanech',...
'Visible','off');


h19 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'Callback','demonstration_export(''lancer_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.149448345035105 0.234011627906977 0.151454363089268 0.0377906976744186],...
'String','Go!',...
'Tag','lancer');


h20 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'BackgroundColor',[1 1 1],...
'Callback','demonstration_export(''results_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.0491474423269809 0.125 0.352056168505517 0.0741279069767442],...
'String','Results',...
'Style','edit',...
'CreateFcn','demonstration_export(''results_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','results');


h21 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'Callback','demonstration_export(''methode_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.299899699097292 0.818313953488372 0.151454363089268 0.0348837209302326],...
'String',{ 'Cholesky' 'QR' 'Sherman Morisson' },...
'Style','popupmenu',...
'Value',1,...
'CreateFcn','demonstration_export(''methode_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','methode');


h22 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'BackgroundColor',[1 1 1],...
'Callback','demonstration_export(''nbapp_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.400200601805416 0.52906976744186 0.0511534603811434 0.0305232558139535],...
'String','100',...
'Style','edit',...
'CreateFcn','demonstration_export(''nbapp_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','nbapp');


h23 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'BackgroundColor',[1 1 1],...
'Callback','demonstration_export(''nbtest_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.400200601805416 0.469476744186047 0.0511534603811434 0.0305232558139535],...
'String','100',...
'Style','edit',...
'CreateFcn','demonstration_export(''nbtest_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','nbtest');


h24 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'BackgroundColor',[1 1 1],...
'Callback','demonstration_export(''dataSigma_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.400200601805416 0.409883720930233 0.0511534603811434 0.0305232558139535],...
'String','0.5',...
'Style','edit',...
'CreateFcn','demonstration_export(''dataSigma_CreateFcn'',gcbo,[],guidata(gcbo))',...
'Tag','dataSigma');


h25 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'ListboxTop',0,...
'Position',[0.299899699097292 0.526162790697674 0.0601805416248746 0.0348837209302326],...
'String','Nb App',...
'Style','text',...
'Tag','text3');


h26 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'ListboxTop',0,...
'Position',[0.299899699097292 0.462209302325581 0.0601805416248746 0.0348837209302326],...
'String','Nb Test',...
'Style','text',...
'Tag','text4');


h27 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'ListboxTop',0,...
'Position',[0.299899699097292 0.398255813953488 0.0601805416248746 0.0348837209302326],...
'String','Coef Data',...
'Style','text',...
'Tag','text5');


h28 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'ListboxTop',0,...
'Position',[0.0491474423269809 0.633720930232558 0.0842527582748245 0.0348837209302326],...
'String','Slack variable',...
'Style','text',...
'Tag','text6');


h29 = uicontrol(...
'Parent',h1,...
'Units','normalized',...
'Callback','demonstration_export(''zoomin_Callback'',gcbo,[],guidata(gcbo))',...
'ListboxTop',0,...
'Position',[0.504595588235294 0.0416666666666667 0.0597426470588235 0.0445402298850575],...
'String','zoom in',...
'Tag','zoomin');



hsingleton = h1;


% --- Handles default GUIDE GUI creation and callback dispatch
function varargout = gui_mainfcn(gui_State, varargin)


%   GUI_MAINFCN provides these command line APIs for dealing with GUIs
%
%      DEMONSTRATION_EXPORT, by itself, creates a new DEMONSTRATION_EXPORT or raises the existing
%      singleton*.
%
%      H = DEMONSTRATION_EXPORT returns the handle to a new DEMONSTRATION_EXPORT or the handle to
%      the existing singleton*.
%
%      DEMONSTRATION_EXPORT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEMONSTRATION_EXPORT.M with the given input arguments.
%
%      DEMONSTRATION_EXPORT('Property','Value',...) creates a new DEMONSTRATION_EXPORT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before untitled_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to untitled_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".

%   Copyright 1984-2002 The MathWorks, Inc.
%   $Revision: 1.6 $ $Date: 2005/01/06 16:06:03 $

gui_StateFields =  {'gui_Name'
                    'gui_Singleton'
                    'gui_OpeningFcn'
                    'gui_OutputFcn'
                    'gui_LayoutFcn'
                    'gui_Callback'};
gui_Mfile = '';
for i=1:length(gui_StateFields)
    if ~isfield(gui_State, gui_StateFields{i})
        error('Could not find field %s in the gui_State struct in GUI M-file %s', gui_StateFields{i}, gui_Mfile);        
    elseif isequal(gui_StateFields{i}, 'gui_Name')
        gui_Mfile = [getfield(gui_State, gui_StateFields{i}), '.m'];
    end
end

numargin = length(varargin);

if numargin == 0
    % DEMONSTRATION_EXPORT
    % create the GUI
    gui_Create = 1;
elseif numargin > 3 & ischar(varargin{1}) & ishandle(varargin{2})
    % DEMONSTRATION_EXPORT('CALLBACK',hObject,eventData,handles,...)
    gui_Create = 0;
else
    % DEMONSTRATION_EXPORT(...)
    % create the GUI and hand varargin to the openingfcn
    gui_Create = 1;
end

if gui_Create == 0
    varargin{1} = gui_State.gui_Callback;
    if nargout
        [varargout{1:nargout}] = feval(varargin{:});
    else
        feval(varargin{:});
    end
else
    if gui_State.gui_Singleton
        gui_SingletonOpt = 'reuse';
    else
        gui_SingletonOpt = 'new';
    end
    
    % Open fig file with stored settings.  Note: This executes all component
    % specific CreateFunctions with an empty HANDLES structure.
    
    % Do feval on layout code in m-file if it exists
    if ~isempty(gui_State.gui_LayoutFcn)
        gui_hFigure = feval(gui_State.gui_LayoutFcn, gui_SingletonOpt);
    else
        gui_hFigure = local_openfig(gui_State.gui_Name, gui_SingletonOpt);            
        % If the figure has InGUIInitialization it was not completely created
        % on the last pass.  Delete this handle and try again.
        if isappdata(gui_hFigure, 'InGUIInitialization')
            delete(gui_hFigure);
            gui_hFigure = local_openfig(gui_State.gui_Name, gui_SingletonOpt);            
        end
    end
    
    % Set flag to indicate starting GUI initialization
    setappdata(gui_hFigure,'InGUIInitialization',1);

    % Fetch GUIDE Application options
    gui_Options = getappdata(gui_hFigure,'GUIDEOptions');
    
    if ~isappdata(gui_hFigure,'GUIOnScreen')
        % Adjust background color
        if gui_Options.syscolorfig 
            set(gui_hFigure,'Color', get(0,'DefaultUicontrolBackgroundColor'));
        end

        % Generate HANDLES structure and store with GUIDATA
        guidata(gui_hFigure, guihandles(gui_hFigure));
    end
    
    % If user specified 'Visible','off' in p/v pairs, don't make the figure
    % visible.
    gui_MakeVisible = 1;
    for ind=1:2:length(varargin)
        if length(varargin) == ind
            break;
        end
        len1 = min(length('visible'),length(varargin{ind}));
        len2 = min(length('off'),length(varargin{ind+1}));
        if ischar(varargin{ind}) & ischar(varargin{ind+1}) & ...
                strncmpi(varargin{ind},'visible',len1) & len2 > 1
            if strncmpi(varargin{ind+1},'off',len2)
                gui_MakeVisible = 0;
            elseif strncmpi(varargin{ind+1},'on',len2)
                gui_MakeVisible = 1;
            end
        end
    end
    
    % Check for figure param value pairs
    for index=1:2:length(varargin)
        if length(varargin) == index
            break;
        end
        try, set(gui_hFigure, varargin{index}, varargin{index+1}), catch, break, end
    end

    % If handle visibility is set to 'callback', turn it on until finished
    % with OpeningFcn
    gui_HandleVisibility = get(gui_hFigure,'HandleVisibility');
    if strcmp(gui_HandleVisibility, 'callback')
        set(gui_hFigure,'HandleVisibility', 'on');
    end
    
    feval(gui_State.gui_OpeningFcn, gui_hFigure, [], guidata(gui_hFigure), varargin{:});
    
    if ishandle(gui_hFigure)
        % Update handle visibility
        set(gui_hFigure,'HandleVisibility', gui_HandleVisibility);
        
        % Make figure visible
        if gui_MakeVisible
            set(gui_hFigure, 'Visible', 'on')
            if gui_Options.singleton 
                setappdata(gui_hFigure,'GUIOnScreen', 1);
            end
        end

        % Done with GUI initialization
        rmappdata(gui_hFigure,'InGUIInitialization');
    end
    
    % If handle visibility is set to 'callback', turn it on until finished with
    % OutputFcn
    if ishandle(gui_hFigure)
        gui_HandleVisibility = get(gui_hFigure,'HandleVisibility');
        if strcmp(gui_HandleVisibility, 'callback')
            set(gui_hFigure,'HandleVisibility', 'on');
        end
        gui_Handles = guidata(gui_hFigure);
    else
        gui_Handles = [];
    end
    
    if nargout
        [varargout{1:nargout}] = feval(gui_State.gui_OutputFcn, gui_hFigure, [], gui_Handles);
    else
        feval(gui_State.gui_OutputFcn, gui_hFigure, [], gui_Handles);
    end
    
    if ishandle(gui_hFigure)
        set(gui_hFigure,'HandleVisibility', gui_HandleVisibility);
    end
end    

function gui_hFigure = local_openfig(name, singleton)
if nargin('openfig') == 3 
    gui_hFigure = openfig(name, singleton, 'auto');
else
    % OPENFIG did not accept 3rd input argument until R13,
    % toggle default figure visible to prevent the figure
    % from showing up too soon.
    gui_OldDefaultVisible = get(0,'defaultFigureVisible');
    set(0,'defaultFigureVisible','off');
    gui_hFigure = openfig(name, singleton);
    set(0,'defaultFigureVisible',gui_OldDefaultVisible);
end

