function carpette_online(nbapp)

global svModel;
%--------------------------------------------------
n='carpette';
nbtest = 1000;
[xapp,yapp,xtest,ytest]=dataset(n,nbapp,nbtest);
%nbclass = 4;

%-----------------------------------------------------
%   Learning and Learning Parameters
C = inf;
p = 1;
k = 'rbf';
noyau = kernel(k,p);
tolerance = 1e-5;
pas = 50;
meth = 'chol';
multiclass = '1vsall';
parametres = param(C,pas,multiclass,meth,tolerance);
parametres.verbose=0;
temps = zeros(nbapp,1);
temps2 = zeros(nbapp+1,1);
sv = zeros(nbapp,1);
y = zeros(nbapp,1);

%---------------------One Against All algorithms----------------
%init = cputime;
donnees = data(xapp(:,1:10),yapp(1:10),xtest,ytest);
trainSVM(donnees,noyau,parametres);
temps2(1:11)=0;
for o = 11:1:nbapp
    donnees = data(xapp(:,1:o),yapp(1:o),xtest,ytest);
    tic;
    trainSVM(donnees,noyau,parametres,svModel.model);
    temps(o) = toc;
    temps2(o+1) = temps2(o)+temps(o);
    sv(o) = length(svModel.model.indices{1});
    [yi]=testSVM;
    y(o) = length(find(yi(:,1)-ytest))/nbtest;
    if mod(o,50)==0
        subplot(2,2,1)
        plot(11:length(sv),sv(11:end));
        title('Size of the solution evolution');
        xlabel('size of training set');
        ylabel('number of support vectors');
        subplot(2,2,2)
        plot(11:length(sv),y(11:end));
        title('Error rate evolution');
        xlabel('size of training set');
        ylabel('error rate');
        subplot(2,2,3)
        plot(log(11:length(sv)),log(temps2(12:end)));
        title('Complexity of the on-line learning');
        xlabel('log size of training set');
        ylabel('log of cumulative computing time');
        subplot(2,2,4)
        plot(log(11:length(sv)),log(temps(11:end)));
        title('Complexity of the on-line learning');
        xlabel('log size of training set');
        ylabel('log of each step computing time');
        drawnow;
    end    
end
subplot(2,2,1)
plot(1:length(sv),sv);
title('Size of the solution evolution');
xlabel('size of training set');
ylabel('number of support vectors');
subplot(2,2,2)
plot(1:length(sv),y);
title('Error rate evolution');
xlabel('size of training set');
ylabel('error rate');
subplot(2,2,3)
plot(log(1:length(sv)),log(temps2(2:end)));
title('Complexity of the on-line learning');
xlabel('log size of training set');
ylabel('log of cumulative computing time');
subplot(2,2,4)
plot(log(1:length(sv)),log(temps));
title('Complexity of the on-line learning');
xlabel('log size of training set');
ylabel('log of each step computing time');


% %---------------------One Against One algorithms----------------
% 
% % %-----------------------------------------------------
% % %   Learning and Learning Parameters
% C = inf;
% % tolerance = 1e-5;
% p = 5;
% kernel = 'rbf';
% d = svm_kernel(kernel,p);
% % b = 0;
% % pas = 50;
% % meth = 'shmo';
% 
% % C = 300;
% % p = 8;
% % scale = 1;
% % d = svm_kernel('poly',[p,scale]);
% 
% [alpha,pos,nbsv,b,xsup] = OnLineSVM_1vs1(d,C,nbclass,meth,pas,tolerance,yapp,xapp);
% figure;
% [ypred]=OnLineSVM_1vs1_val(d,alpha,pos,nbsv,b,nbclass,xsup,xtest');
% ypredmat=reshape(ypred(:,1),na,nb);
% contourf(xtesta1,xtesta2,ypredmat,30);shading flat
% hold on
% [cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'k');
% clabel(cs,h);
% for i=1:nbclass
%     h1=plot(xapp(1,yapp==i),xapp(2,yapp==i),[style(i) color(i)]); 
%     set(h1,'LineWidth',2);
% end; 
% 
% %h=plot(xapp(1,pos),xapp(2,pos),'or');
% %set(h,'LineWidth',2);
% colormap(gray);
% % legend('classe 1','classe 2','classe 3','classe 4', 'Support Vector');
% hold off
% if kernel=='rbf'
% print('-depsc',['carpette_1vs1_',kernel,'_C',num2str(C),'_sigma',num2str(p(1))]);
% elseif kernel=='poly'
% print('-depsc',['carpette_1vs1_',kernel,'_C',num2str(C),'_ordre',num2str(p(1)),'_offset',num2str(p(2))]);
% end



