%
% Example MultiClass SVM Classifiction
% "One against Others"
%
%
%

function exmulticlass(method) 

close all
global svModel;
%--------------------------------------------------
n=20;
sigma=1;
x1=sigma*randn(1,n)-1.4;
x2=sigma*randn(1,n)+0;
x3=sigma*randn(1,n)+2;

y1=sigma*randn(1,n)-1.4;
y2=sigma*randn(1,n)+2;
y3=sigma*randn(1,n)-1.4;

xapp=[x1 x2 x3;y1 y2 y3]';
yapp=[1*ones(1,n) 2*ones(1,n) 3*ones(1,n)]';
nbclass=3;
[n1, n2]=size(xapp);
[xtesta1,xtesta2]=meshgrid([-4:0.1:4],[-4:0.1:4]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2];
nbclass = 3;
donnees = data(xapp',yapp,xtest);

%-----------------------------------------------------
%   Learning and Learning Parameters
C = 1000;
tolerance = 1e-5;
noyau = kernel('rbf',5);
pas = 50;
multiclass = '1vsall';
% meth = 'qr';
parametres = param(C,pas,multiclass,method,tolerance);

%---------------------One Against All algorithms----------------
trainSVM(donnees, noyau, parametres);
ypred = testSVM;
ypredmat=reshape(ypred(:,1),na,nb);
contourf(xtesta1,xtesta2,ypredmat);shading flat
colormap('gray');
style=['x+*'];
color=['brg'];
hold on
for i=0:nbclass-1
    h=plot(xapp(i*n+1:(i+1)*n,1),xapp(i*n+1:(i+1)*n,2),[style(i+1) color(i+1)]);
    set(h,'LineWidth',2);
    hold on
end; 

[cc, hh]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'m-'); 
%h=plot(xapp(svModel.model.indices{1},1),xapp(svModel.model.indices{1},2),'om');
%set(h,'LineWidth',2);
axis( [ -4 4 -4 4]);
legend('classe 1','classe 2','classe 3');
hold off
clear global svModel;



