%
%  example of multiclass problem
%  This is the one that can be found in 
%   Lin & Wahba Tech Rep 
%
%
%
%  22/08/2002 AR

function exmulticlass1(method) 
close all
n=100;
nbtest=500;
nbiter=5;

for i=1:nbiter
    global svModel;
    fprintf('%d...\n',i);
    vector_training=rand(n,1);
    auxy=rand(n,1);
    vector_test=linspace(0,1,nbtest)';
    auxytest=rand(nbtest,1);
    %-------------------------------- DATA Generation --------------------------------% 
    p1=0.97*exp(-3*vector_training);
    p3= exp(-2.5*(vector_training-1.2).^ 2);
    p2=1-p1-p3;
    label_training= 1*(auxy <=p1) + 2*(auxy > p1 &auxy <=p1+p2) + 3*(auxy > p1+p2 &auxy <=p1+p2 +3);
    p1=0.97*exp(-3*vector_test);
    p3= exp(-2.5*(vector_test-1.2).^ 2);
    p2=1-p1-p3;
    label_test= 1*(auxytest <=p1) + 2*(auxytest > p1 &auxytest <=p1+p2) + 3*(auxytest > p1+p2 &auxytest <=p1+p2 +3);
    %plot(x,y,'rx',xtest,ytest,'bx');
    
    %--------------------------------- Real pdf  --------------------------------------% 
    x1=linspace(0,1,1000);
    p1=0.97*exp(-3*x1);
    p3= exp(-2.5*(x1-1.2).^ 2);
    p2=1-p1-p3;
    %---------------------------------------------------------------------------------%
    
    nbclass=3;
    multiclass = '1vsall';
    C = 100;
    tolerance = 1e-5;
    noyau = kernel('rbf',1);
    pas = 5;
    % meth = 'qr';
    parametres = param(C,pas,multiclass,method,tolerance);
    donnees = data(vector_training',label_training,vector_test');
    trainSVM(donnees,noyau,parametres);
    ypred=testSVM;
    ypred1=ypred(:,1)==1;
    ypred2=ypred(:,1)==2;
    ypred3=ypred(:,1)==3;
    
    %  Estimating the Bayes Threshold for the problem
    ind1=find(ypred1==1);
    if ~isempty(ind1)
        bayesthresh1(i)=vector_test(ind1(end));
    else
        bayesthresh1(i)=0;
    end;
    
    ind3=find(ypred3==1);
    if ~isempty(ind3)
        bayesthresh3(i)=vector_test(ind3(1));
    else
        bayesthresh1(i)=1;
    end;
    clear global svModel;
end;

fprintf('\nMean Threshold 1:%2.2f \t  \t 2: %2.2f \n', mean(bayesthresh1),mean(bayesthresh3));

figure(1);
plot(x1,p1,'r',x1,p2,'b',x1,p3,'k');
legend('Class 1','Class 2', 'Class 3');
title('Conditional probabilities of each class');
hold on
plot(vector_test,ypred1,'r',vector_test,ypred2,'b',vector_test,ypred3,'k');