function multicarpette(method)
close all
global svModel;

%--------------------------------------------------
n='carpette';
nbapp = 10000;
nbtest = 100;
[xapp,yapp,xtest,ytest]=dataset(n,nbapp,nbtest);
nbclass = 4;
y = zeros(length(yapp),nbclass);
for i=1:nbclass
    y(find(yapp==i),i)=1;
end
[xtesta1,xtesta2]=meshgrid([-1:0.02:1],[-1:0.02:1]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2];
donnees = data(xapp,y',xtest);
%-----------------------------------------------------
%   Learning and Learning Parameters
C = 10;
p = 20;
ker = 'rbf';
noyau = kernel(ker,p);
tolerance = 1e-5;
pas = 50;
multiclass = '';
method='chol';
parametres = param(C,pas,multiclass,method,tolerance);
parametres.type='VO';

tic
trainSVM(donnees,noyau,parametres);
toc
[ypred]=testSVM;
[m,ypred] = max(ypred,[],2);
ypredmat=reshape(ypred,na,nb);
contourf(xtesta1,xtesta2,ypredmat,30);shading flat
style=['x+*v'];
color=['ybcg'];
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'k');
clabel(cs,h);
% for i=1:nbclass
%     h1=plot(xapp(1,yapp==i),xapp(2,yapp==i),[style(i) color(i)]); 
%     set(h1,'LineWidth',2);
% end; 
axis( [ -1 1 -1 1]);
colormap(gray);
title('Carpette Problem with VO');
hold off




