%
% Example MultiClass SVM Classifiction
% "One against Others"
%

close all
global meth;

%--------------------------------------------------
n='multiclasscheckers';
sigma=2;
nbapp = 500;
nbtest = 100;
[xapp,yapp,xtest,ytest,xtest1,xtest2]=dataset(n,nbapp,nbtest,sigma);
nbclass = 4;

%-----------------------------------------------------
%   Learning and Learning Parameters
C = inf;
tolerance = 1e-5;
p = 30;
kernel = 'rbf';
d = svm_kernel(kernel,p);
b = 0;
pas = 50;
meth = 'shmo';

%---------------------One Against All algorithms----------------
[alpha,pos,nbsv,b] = OnLineSVM_1vs_all(d,C,nbclass,meth,pas,tolerance,yapp,xapp);

[xtesta1,xtesta2]=meshgrid([-2:0.05:2],[-2:0.05:2]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2]';
[ypred,maxi]=OnLineSVM_1vs_all_val(d,alpha,pos,nbsv,b,yapp,xtest',xapp);
ypredmat=reshape(ypred,na,nb);
contourf(xtesta1,xtesta2,ypredmat,30);shading flat
style=['x+*v'];
color=['ybcg'];
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'k');
clabel(cs,h);
for i=1:nbclass
    h1=plot(xapp(1,yapp==i),xapp(2,yapp==i),[style(i) color(i)]); 
    set(h1,'LineWidth',2);
end; 

%h=plot(xapp(1,pos),xapp(2,pos),'or');
%set(h,'LineWidth',2);
axis( [ -2 2 -2 2]);
colormap(gray);
% legend('classe 1','classe 2','classe 3','classe 4', 'Support Vector');
hold off
if kernel=='rbf'
print('-depsc',['checkers_1vsall_',kernel,'_C',num2str(C),'_sigma',num2str(p(1))]);
elseif kernel=='poly'
print('-depsc',['checkers_1vsall_',kernel,'_C',num2str(C),'_ordre',num2str(p(1)),'_offset',num2str(p(2))]);
end

%---------------------One Against One algorithms----------------

%-----------------------------------------------------
%   Learning and Learning Parameters
C = inf;
tolerance = 1e-5;
p = 15;
kernel = 'rbf';
d = svm_kernel(kernel,p);
b = 0;
pas = 50;
meth = 'shmo';

[alpha,pos,nbsv,b,xsup] = OnLineSVM_1vs1(d,C,nbclass,meth,pas,tolerance,yapp,xapp);
figure;
[xtesta1,xtesta2]=meshgrid([-2:0.05:2],[-2:0.05:2]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2]';
[ypred]=OnLineSVM_1vs1_val(d,alpha,pos,nbsv,b,nbclass,xsup,xtest');
ypredmat=reshape(ypred(:,1),na,nb);
contourf(xtesta1,xtesta2,ypredmat,30);shading flat
style=['x+*v'];
color=['ybcg'];
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'k');
clabel(cs,h);
for i=1:nbclass
    h1=plot(xapp(1,yapp==i),xapp(2,yapp==i),[style(i) color(i)]); 
    set(h1,'LineWidth',2);
end; 

%h=plot(xapp(1,pos),xapp(2,pos),'or');
%set(h,'LineWidth',2);
axis( [ -2 2 -2 2]);
colormap(gray);
% legend('classe 1','classe 2','classe 3','classe 4', 'Support Vector');
hold off
if kernel=='rbf'
print('-depsc',['checkers_1vs1_',kernel,'_C',num2str(C),'_sigma',num2str(p(1))]);
elseif kernel=='poly'
print('-depsc',['checkers_1vs1_',kernel,'_C',num2str(C),'_ordre',num2str(p(1)),'_offset',num2str(p(2))]);
end