%
%  SVM Classification 2D examples
%
%  15/06/00 AR

function exclass(method) 
close all
global svModel;

%-------------Data Set-------------------------------------
nbapp=200;
nbtest=10;
sigma=2;
[vector_training_set,label_training_set,vector_test_set,label_test_set]=dataset('Checkers',nbapp,nbtest,sigma);
donnees = data(vector_training_set,label_training_set,vector_test_set,label_test_set);
%-----------------------------------------------------
%   Learning and Learning Parameters
% meth = 'qr';
multiclass = '';
C = 500;
tolerance = .00001;
noyau = kernel('rbf',.9);
pas = 50;
parametres = param(C,pas,multiclass,method,tolerance);
trainSVM(donnees, noyau, parametres);
%--------------Testing Generalization performance ---------------
[xtesta1,xtesta2]=meshgrid([-4:0.1:4],[-4:0.1:4]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2]';
svModel.data.testvec = xtest';
[ypred] = testSVM;
ypredmat=reshape(ypred(:,1),na,nb);
%----------------------Plotting---------------------------------

ind1=find(ypred>0);
indm1=find(ypred<0);

contourf(xtesta1,xtesta2,ypredmat,50);shading flat;
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'k');
clabel(cs,h);
h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+k'); 
set(h1,'LineWidth',2);

h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'xk'); 
set(h2,'LineWidth',2);
h3=plot(vector_training_set(1,svModel.model.indices{1}),vector_training_set(2,svModel.model.indices{1}),'ok'); 
set(h3,'LineWidth',2);



xlabel('x1');ylabel('x2');
title('Learning Data and Margin ');
axis([-2 2 -2 2]);
clear global svModel;
