% test cross validation



close all
global svModel;

%-------------Data Set-------------------------------------

nbapp=100;
nbtest=500;
sigma=2;
[vector_training_set,label_training_set,vector_test_set,label_test_set]=dataset('Checkers',nbapp,nbtest,sigma);
rn = randperm(length(label_training_set));
donnees = data(vector_training_set(:,rn),label_training_set(rn),vector_test_set,label_test_set);

%-----------------------------------------------------

%   Learning and Learning Parameters
meth = 'chol';
multiclass = '';
C = inf;
tolerance = .00001;
noyau = kernel('rbf',2);
pas = 100;
parametres = param(C,pas,multiclass,meth,tolerance);
% parametres.verbose = 0;
p = [0.5 1 2 3 5]; 
slacks = [inf];
nbFolders = 5;
tic;
[bestP, bestC, maxPerf , perfs] = leaveOneOut(donnees,parametres, noyau, p, slacks);
toc

% %--------------Testing Generalization performance ---------------

noyau = kernel('rbf',bestP);
parametres.C = bestC;
trainSVM(donnees, noyau, parametres);
prediction = testSVM;
perf1 = length(find(sign(donnees.testlab)==sign(prediction(:,1))))/length(prediction(:,1));
perf2 = length(find(donnees.testlab==prediction(:,1)))/length(prediction(:,1));
fprintf(1,'performance en test: %2.2f \n',100*perf1);
fprintf(1,'best P: %2.2f \n best C: %2.2f',bestP, bestC);
% fprintf(1,'performance en test: %2.2f \n',100*perf2);





[xtesta1,xtesta2]=meshgrid([-4:0.1:4],[-4:0.1:4]);

[na,nb]=size(xtesta1);

xtest1=reshape(xtesta1,1,na*nb);

xtest2=reshape(xtesta2,1,na*nb);

xtest=[xtest1;xtest2]';

svModel.data.testvec = xtest';

[ypred] = testSVM;

ypredmat=reshape(ypred(:,1),na,nb);

%----------------------Plotting---------------------------------



ind1=find(ypred>0);

indm1=find(ypred<0);



contourf(xtesta1,xtesta2,ypredmat,50);shading flat;

hold on

[cs,h]=contour(xtesta1,xtesta2,ypredmat,[-1 0 1],'k');

%[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'k');

clabel(cs,h);

%h1=plot(vector_training_set(1,label_training_set==1),vector_training_set(2,label_training_set==1),'+k'); 

%set(h1,'LineWidth',2);



%h2=plot(vector_training_set(1,label_training_set==-1),vector_training_set(2,label_training_set==-1),'xk'); 

%set(h2,'LineWidth',2);

h3=plot(svModel.data.trainvec(1,svModel.model.indices{1}),svModel.data.trainvec(2,svModel.model.indices{1}),'ok'); 

set(h3,'LineWidth',2);







xlabel('x1');ylabel('x2');

title('Learning Data and Margin ');

axis([-2 2 -2 2]);

clear global svModel;

