%close all
global svModel;
randn('seed',0);
rand('seed',0);
%--------------------------------------------------
%n='multiclassgaussian';
n = 'multiclasscheckers';
nbapp = 200;
nbtest = 100;
[xapp,yapp,xtest,ytest]=dataset(n,nbapp,nbtest,0.5);
nbclass = 4;
%y = -ones(length(yapp),nbclass);
y = zeros(length(yapp),nbclass);
for i=1:nbclass
    y(find(yapp==i),i)=1;
end
SS = 2;
pas = 0.05;
[xtesta1,xtesta2]=meshgrid([-SS:pas:SS],[-SS:pas:SS]);
[na,nb]=size(xtesta1);
xtest1=reshape(xtesta1,1,na*nb);
xtest2=reshape(xtesta2,1,na*nb);
xtest=[xtest1;xtest2];
donnees = data(xapp,y',xtest);
%-----------------------------------------------------
%   Learning and Learning Parameters
C = 1000;
p = 0.8;
ker = 'rbf';
noyau = kernel(ker,p);
tolerance = 1e-9;
pas = 200;
multiclass = '';
method='chol';
parametres = param(C,pas,multiclass,method,tolerance);
parametres.type='VO';

tic
trainSVM(donnees,noyau,parametres);
toc
[ypred]=testSVM;

[m,ypred] = max(ypred,[],2);
ypredmat=reshape(ypred,na,nb);
figure;
contourf(xtesta1,xtesta2,ypredmat,30);shading flat
style=['....'];
color=['ybcm'];
hold on
[cs,h]=contour(xtesta1,xtesta2,ypredmat,[1 2 3 4],'k');
clabel(cs,h);
for i=1:nbclass
    h1=plot(xapp(1,yapp==i),xapp(2,yapp==i),[style(i) color(i)]); 
    set(h1,'LineWidth',1);
end; 
% svModel.model.indices{1}
% xapp(:,svModel.model.indices{1})
h1=plot(xapp(1,svModel.model.indices{1}),xapp(2,svModel.model.indices{1}),'ro');
set(h1,'LineWidth',3);
%axis( [ -2 2 -2 2]);
colormap(gray);
title(['Problem with VO, noyau ',ker,' avec \gamma=',num2str(p)]);
hold off




