function sv_qrup(u,v,ind,dec)

global svModel;
global temporarelyDataNeeded;

% sv_qrup
% 
% This function performs updates of the Q and R matrices.
%
% Inputs : 
%       q : previous q 
%       r : previous r
%       ind : indice of the modified column and line
%       u : values added to the modified column of the non inverted matrix
%       v : values added to the modified row of the non inverted matrix
%       dec : 1 if the size of q and r is to be decreased 0 if it is to be
%       incresed.
% 
% Outputs : 
%       q : orthogonal matrix of the QR decomposition
%       r : triangular matrix of the QR decomposition
%
%
% Usage : 
% [q,r] = sv_qrup(q,r,u,v,ind,dec)
%
% See also : 
% 

% Author(s) : Gaelle Loosli
% Creation : january 2004
% Update : march 2004

n = length(u);
if n==1
      [svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H),...
      svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)] = qr(u);      
else
      if dec==0
            svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H(ind),temporarelyDataNeeded.n_H(ind))=1;
      end
      l = [zeros(ind-1,1);1;zeros(n-ind,1)];
      [svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H),...
      svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)] =...
       qrupdate(svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H),...
       svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H),u,l);
      if dec==0
            v(ind) = 0;
      end
      [svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H),...
      svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)] =...
       qrupdate(svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H),...
       svModel.model.G2{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H),l,v);
end
