function relaxConstraint

global svModel;
global temporarelyDataNeeded;

n = length(svModel.data.trainlab);
nu = zeros(n,1);
temporarelyDataNeeded.xt = zeros(n,1);
temporarelyDataNeeded.xt(temporarelyDataNeeded.bounded) = svModel.param.C(temporarelyDataNeeded.bounded);
temporarelyDataNeeded.xt(temporarelyDataNeeded.active) = svModel.model.alpha{svModel.model.iclass};

% Are the points well classified?
%===================================================================
fx=kernelPol(svModel.kernel,svModel.data.trainvec(:,temporarelyDataNeeded.indpoints), ...
      svModel.data.trainvec(:,[temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]),...
      svModel.data.trainlab(temporarelyDataNeeded.indpoints),...
      svModel.data.trainlab([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]));
if length(svModel.param.span)>0
    nu(temporarelyDataNeeded.indpoints) = fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
      ones(length(temporarelyDataNeeded.indpoints),1)+ ...
      (svModel.data.trainlab([temporarelyDataNeeded.indpoints])*ones(1,length(temporarelyDataNeeded.indpoints)))*svModel.model.span(temporarelyDataNeeded.indpoints,:)*svModel.model.mu{svModel.model.iclass};      
elseif length(svModel.param.weighs)>0
    nu(temporarelyDataNeeded.indpoints) = (fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) +...
      svModel.data.trainlab([temporarelyDataNeeded.indpoints])*svModel.model.mu{svModel.model.iclass})./...
      svModel.param.weighs(temporarelyDataNeeded.indpoints) -  ...    
      ones(length(temporarelyDataNeeded.indpoints),1); 
else
    nu(temporarelyDataNeeded.indpoints) = fx*temporarelyDataNeeded.xt([temporarelyDataNeeded.active;temporarelyDataNeeded.bounded]) -...
      ones(length(temporarelyDataNeeded.indpoints),1)+ ... 
      svModel.data.trainlab([temporarelyDataNeeded.indpoints])*svModel.model.mu{svModel.model.iclass};   
        %svModel.param.tube(temporarelyDataNeeded.indpoints)'+ ... 
end
    
     %nu(temporarelyDataNeeded.indpoints)  
indsat = temporarelyDataNeeded.n_bounded+1:length(temporarelyDataNeeded.indpoints);


% % gestion du skrinking
% bhist0 = find(nu(temporarelyDataNeeded.indpoints(indsat))>svModel.param.gap);
% temporarelyDataNeeded.bhist0(temporarelyDataNeeded.indpoints(indsat(bhist0))) = ...
%     temporarelyDataNeeded.bhist0(temporarelyDataNeeded.indpoints(indsat(bhist0)))+1;
% temporarelyDataNeeded.bloc0 = find(temporarelyDataNeeded.bhist0>svModel.param.shrinkdelay);
% temporarelyDataNeeded.inactive = setdiff(temporarelyDataNeeded.inactive,temporarelyDataNeeded.bloc0);
% % fin de gestion du shrinking

[mm mpos]=min(nu(temporarelyDataNeeded.indpoints(indsat)));
[mmS mposS]=min(-nu(temporarelyDataNeeded.bounded));
% in case not
%===================================================================

if (~isempty(mm) & (mm < -svModel.param.gap))  |...
        (~isempty(mmS) & (mmS <  -svModel.param.gap)) % make another point become active
      if (isempty(temporarelyDataNeeded.bounded) | (mm < mmS))  % put a point from inactive set to active set
            temporarelyDataNeeded.active = sort([temporarelyDataNeeded.active ; temporarelyDataNeeded.indpoints(indsat(mpos))]);  
            temporarelyDataNeeded.x = temporarelyDataNeeded.xt(temporarelyDataNeeded.active);
            temporarelyDataNeeded.new_active = temporarelyDataNeeded.indpoints(indsat(mpos));
            temporarelyDataNeeded.inactive = setdiff(temporarelyDataNeeded.inactive,temporarelyDataNeeded.new_active);
            temporarelyDataNeeded.countVS(temporarelyDataNeeded.new_active) = temporarelyDataNeeded.countVS(temporarelyDataNeeded.new_active)+1;
      else % put a point from bounded set to active set
            temporarelyDataNeeded.active = sort([temporarelyDataNeeded.active ; temporarelyDataNeeded.bounded(mposS)]); 
            temporarelyDataNeeded.x = temporarelyDataNeeded.xt(temporarelyDataNeeded.active);                           
            temporarelyDataNeeded.new_active = temporarelyDataNeeded.bounded(mposS);
            temporarelyDataNeeded.bounded(mposS)=[];
            temporarelyDataNeeded.boundedback = 1;
      end
      %temporarelyDataNeeded.countVS(temporarelyDataNeeded.new_active) = temporarelyDataNeeded.countVS(temporarelyDataNeeded.new_active)+1;
      test=1;
      temporarelyDataNeeded.nb_test=0;
% elseif temporarelyDataNeeded.nb_test==0 % no candidate point in the tested set
%       %temporarelyDataNeeded.nb_test = temporarelyDataNeeded.indpoints(end);
%       temporarelyDataNeeded.nb_test = temporarelyDataNeeded.nb_test + 1;
%       temporarelyDataNeeded.new_active = 0;
else
      temporarelyDataNeeded.new_active = 0;
      temporarelyDataNeeded.nb_test = temporarelyDataNeeded.nb_test + 1;
end

