function solveLinearSystem % sherman morisson 1 class

global svModel;
global temporarelyDataNeeded;

% calculer le noyau
%===================================================================
if temporarelyDataNeeded.new_active>0 % on a ajout un point
      
      % mise  jour des indices
      temporarelyDataNeeded.n_H = sort([temporarelyDataNeeded.n_H,temporarelyDataNeeded.free(1)]);
      temporarelyDataNeeded.relative(temporarelyDataNeeded.new_active) = temporarelyDataNeeded.free(1);
      temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative(temporarelyDataNeeded.active);
      [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
      if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
      end
      % calcul des nouvelles valeurs de H
      new_valueH =kernelPol(svModel.kernel,...
            svModel.data.trainvec(:,temporarelyDataNeeded.active), ...
            svModel.data.trainvec(:,temporarelyDataNeeded.new_active), ...
            svModel.data.trainlab(temporarelyDataNeeded.active), ...
            svModel.data.trainlab(temporarelyDataNeeded.new_active)); % points dans l'ordre des donnees, donc de actif
      % valeurs pour G
      u = new_valueH(temporarelyDataNeeded.reverse);
      u(temporarelyDataNeeded.free(1)) = u(temporarelyDataNeeded.free(1))+svModel.param.gap;       sherman_morrison(temporarelyDataNeeded.free(1),u);
      % derniere mise  jours
      temporarelyDataNeeded.free(1) = [];
      if isempty(temporarelyDataNeeded.free)
            temporarelyDataNeeded.free = temporarelyDataNeeded.n_active+1;
      end
      
elseif temporarelyDataNeeded.new_active<0 % on a retir un point
      remove = find(temporarelyDataNeeded.n_H==temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)); % place du point  enlever dans nH
      new_valueH =kernelPol(svModel.kernel,...
            svModel.data.trainvec(:,[temporarelyDataNeeded.active;-temporarelyDataNeeded.new_active]), ...
            svModel.data.trainvec(:,-temporarelyDataNeeded.new_active), ...
            svModel.data.trainlab([temporarelyDataNeeded.active;-temporarelyDataNeeded.new_active]), ...
            svModel.data.trainlab(-temporarelyDataNeeded.new_active)); 
      u = -new_valueH(temporarelyDataNeeded.reverse); 
      sherman_morrison(remove,u);
      % suppression des valeurs dans Q et R
      svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)) = 0;
      svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active),temporarelyDataNeeded.n_H) = 0;
      
      % mise  jours des indices
      temporarelyDataNeeded.free = sort([temporarelyDataNeeded.free,temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active)]);
      temporarelyDataNeeded.n_H(remove)=[];            
      temporarelyDataNeeded.inverse = temporarelyDataNeeded.relative(temporarelyDataNeeded.active);
      [temp, temporarelyDataNeeded.reverse] = sort(temporarelyDataNeeded.inverse);
      if max(temporarelyDataNeeded.inverse)>length(temporarelyDataNeeded.inverse)
            [temp, temporarelyDataNeeded.inverse] = sort(temporarelyDataNeeded.reverse);
      end
      temporarelyDataNeeded.relative(-temporarelyDataNeeded.new_active) = 0;
end
      
% mettre les elements dans l'ordre de H!!
if length(svModel.param.span)>0
    A = (svModel.data.trainlab(temporarelyDataNeeded.active)*ones(1,temporarelyDataNeeded.n_active))*svModel.param.span(temporarelyDataNeeded.active,:);
    be = zeros(size(svModel.param.span,2),1);
    A = A(temporarelyDataNeeded.reverse,:);
else
    A = svModel.data.trainlab(temporarelyDataNeeded.active);
    A = A(temporarelyDataNeeded.reverse);
end
ce = ones(1,temporarelyDataNeeded.n_active);
if temporarelyDataNeeded.n_bounded > 0            
      new_valueH = kernelPol(svModel.kernel,...
            svModel.data.trainvec(:,temporarelyDataNeeded.active), ...
            svModel.data.trainvec(:,temporarelyDataNeeded.bounded), ...
            svModel.data.trainlab(temporarelyDataNeeded.active), ...
            svModel.data.trainlab(temporarelyDataNeeded.bounded)); % points dans l'ordre des donnees, donc de actif
      ce= ce - max(svModel.param.C)*(sum(new_valueH,2))';
end
ce = ce(temporarelyDataNeeded.reverse);
M = A'*svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)*A;
svModel.model.mu{svModel.model.iclass} = 1-M\(A'*svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)*ce');
svModel.model.alpha{svModel.model.iclass}=svModel.model.G1{svModel.model.iclass}(temporarelyDataNeeded.n_H,temporarelyDataNeeded.n_H)*(1-A*svModel.model.mu{svModel.model.iclass});
% remettre alpha dans l'ordre de l'active set
svModel.model.alpha{svModel.model.iclass} = svModel.model.alpha{svModel.model.iclass}(temporarelyDataNeeded.inverse);