function pred = testSVM

global svModel

testbatchsize = 100; % examples are tested 100 by 100, so that we can handle large test sets without computing huge matrices



if strcmp(svModel.param.type,'VO')
%     % construction of possible outputs
%     nboutput = 1; i=0;
%     svModel.model.possibleoutputMatrix = svModel.data.trainlab(:,1);
%     while nboutput < size(svModel.data.trainlab,1) & i < size(svModel.data.trainvec,2)
%         i = i+1;
%         count = 0;
%         for j=1:nboutput
%             if svModel.data.trainlab(:,i)==svModel.model.possibleoutputMatrix(:,j)
%                 count = 1;
%             end
%         end
%         if count == 0
%                 svModel.model.possibleoutputMatrix = [svModel.model.possibleoutputMatrix, svModel.data.trainlab(:,i)];
%                 nboutput = nboutput+1;
%         end        
%     end
    nboutput = size(svModel.model.possibleoutputMatrix,2);
    % classification
    for i=1:size(svModel.data.testvec,2)
        pred(i,:) = kernelPolVO(svModel.kernel,...
            repmat(svModel.data.testvec(:,i),1,nboutput),...
            svModel.data.trainvec(:,svModel.model.indices{svModel.model.iclass}), ...
            svModel.model.possibleoutputMatrix,...
            svModel.data.trainlab(:,svModel.model.indices{svModel.model.iclass}))*...
            svModel.model.alpha{svModel.model.iclass};%...
            %+ svModel.model.possibleoutputMatrix'*svModel.model.mu{svModel.model.iclass};
    end
   
else
    if svModel.model.iclass == 1
        startindex = 1;
        ntest = size(svModel.data.testvec,2);  % number of points in the test set
        pred = zeros(ntest,1);
        while startindex <= ntest
            endindex = min(startindex+testbatchsize,ntest);
            testindices = [startindex:endindex];
        
            pred(testindices) = kernelMult(svModel.kernel,...
                svModel.data.testvec(testindices),...
                svModel.data.trainvec(:,svModel.model.indices{svModel.model.iclass}), ...
                svModel.model.alpha{svModel.model.iclass}.*...
                svModel.data.trainlab(svModel.model.indices{svModel.model.iclass}))...
                +svModel.model.mu{svModel.model.iclass};
            
            startindex = endindex+1;
        end
                
        if strcmp(svModel.param.multiclass,'1class')
            pred = pred-1;
        end
    else
        labelMax = max(svModel.data.trainlab_t);
        labelMin = min(svModel.data.trainlab_t);
        nbclass = labelMax-labelMin+1;
        svModel.model.iclass = 0;
        if strcmp(svModel.param.multiclass,'1vsall') % 1 against all
            predt = zeros(size(svModel.data.testvec,2),nbclass);
            for i = labelMin:labelMax
                svModel.model.iclass = svModel.model.iclass+1;
                if strcmp(svModel.param.type, 'invariant')
                    svModel.data.trainlab = [svModel.data.trainlab_t;svModel.data.trainlabInv{svModel.model.iclass}];
                    svModel.data.trainvec = [svModel.data.trainvec_t,svModel.data.trainvecInv{svModel.model.iclass}];
                else
                    svModel.data.trainlab = svModel.data.trainlab_t;
                end
                svModel.data.trainlab(svModel.data.trainlab~=i) = -2;
                svModel.data.trainlab(svModel.data.trainlab==i) = -1;
                svModel.data.trainlab(svModel.data.trainlab==-2) = 1;
                predt(:,svModel.model.iclass) = kernelMult(svModel.kernel,...
                    svModel.data.testvec,...
                    svModel.data.trainvec(:,svModel.model.indices{svModel.model.iclass}), ...
                    svModel.model.alpha{svModel.model.iclass}.*...
                    svModel.data.trainlab(svModel.model.indices{svModel.model.iclass}))...
                    +svModel.model.mu{svModel.model.iclass};
            end
            [maxi,indices]=min(predt,[],2);
            pred = indices - (1- labelMin);
            svModel.data.trainlab = svModel.data.trainlab_t;
            if strcmp(svModel.param.type, 'invariant')
                svModel.data.trainvec = svModel.data.trainvec_t;
            end
        else % 1 against 1 - voting system
            vote=zeros(size(svModel.data.testvec,2),nbclass);
            for i = labelMin:labelMax
                for j = i+1:labelMax
                    svModel.model.iclass = svModel.model.iclass+1;
                    if strcmp(svModel.param.type,'invariant')
                        svModel.data.trainlab = [svModel.data.trainlab_t([find(svModel.data.trainlab_t==i);...
                                    find(svModel.data.trainlab_t==j)]);svModel.data.trainlabInv{svModel.model.iclass}];
                        svModel.data.trainvec = [svModel.data.trainvec_t(:,[find(svModel.data.trainlab_t==i);...
                                    find(svModel.data.trainlab_t==j)]),svModel.data.trainvecInv{svModel.model.iclass}];
                        svModel.data.trainlab(find(svModel.data.trainlab==j))=-1;
                        svModel.data.trainlab(find(svModel.data.trainlab==i))=1;
                    else
                        svModel.data.trainvec = svModel.data.trainvec_t(:,[find(svModel.data.trainlab_t==i);...
                                find(svModel.data.trainlab_t==j)]);
                        svModel.data.trainlab = [ones(size(find(svModel.data.trainlab_t==i),1),1);...
                                -ones(size(find(svModel.data.trainlab_t==j),1),1)];
                    end
                    predt = kernelMult(svModel.kernel,...
                        svModel.data.testvec,...
                        svModel.data.trainvec(:,svModel.model.indices{svModel.model.iclass}), ...
                        svModel.model.alpha{svModel.model.iclass}.*...
                        svModel.data.trainlab(svModel.model.indices{svModel.model.iclass}))...
                        +svModel.model.mu{svModel.model.iclass};
                    indi=find(predt>=0);
                    indj=find(predt<0);
                    vote(indi,i+nbclass-labelMax)=vote(indi,i+nbclass-labelMax)+1;
                    vote(indj,j+nbclass-labelMax)=vote(indj,j+nbclass-labelMax)+1;
                end
            end
            [maxi,indices]=sort(vote,2);
            pred = fliplr(indices) - (1- labelMin);
            svModel.data.trainlab = svModel.data.trainlab_t;
            svModel.data.trainvec = svModel.data.trainvec_t;
        end
    end
end
